<%@ LANGUAGE="JSCRIPT" %><%


// this is a special JScript workaround for testing if an argument is set or not

	$undefined = Request.QueryString("alkdjfalkdjajdslkfjdalsjfdajljf");
	

// get variables passed in from do_organize()

	$page_name = (Request.QueryString("page_name") != $undefined) ? Request.QueryString("page_name") : "" ;
	$action = (Request.QueryString("action") != $undefined) ? Request.QueryString("action") : "" ;


// initialize variables that we might use before setting

	$error_log = "";
	$show_errors = "";
	$pre_render_files = 0;
	$pre_render_files_count = 0;
	$read_page_definitions_from = "";
	$page_definitions = "";
	$latest_mod_date = 0;	
	$latest_mod_date_formatted = "";
	$template = "";
	$settings_used = "";


// define some useful functions

	function get_file($file, $method, $check_last_modified) { // method can be "http", "filesystem", or "auto" (auto looks at $pre_render_files list)
		$text = "";
		$re11 = new RegExp("\/(\.\w.*)", "");
		$re12 = new RegExp("([^\\w-\.\/\?\&\=\%])", "");
		if ($re11.test($file)) { // don't read files whose names start with "."
			$text = show_error("Not authorized to read hidden file named \"" + RegExp.$1 + "\"");
		} else if ($re12.test($file)) { // don't read files whose names contain characters that could be used to read remote files, or to hack into the open command (Perl only)
			$text = show_error("File names can't contain the character " + RegExp.$1); // is there a way to return the whole matched expression, and remove the parentheses around the expression?
		} else {
			
			// first, figure out if we're going to read over HTTP or through the filesystem...
			if (($method == "")||($method == "auto")) {
				if ($pre_render_files) {
					for ($n=0; $n < $pre_render_files.length; $n++) {
						if ($file.indexOf($pre_render_files[$n]) != -1) { $method = "http"; }
					}
				}
			}

			// ...then get the file
			if ($method == "http") {

				// 1) prepare the URL for this type of connection
				$file_URL = absolute_path($file, "http");

				// 2) open a connection to the file
				XHO = Server.CreateObject("Microsoft.XMLHTTP");
				XHO.Open("GET", $file_URL, 0);
				$file_exists = 1; // to do: how can we test for this?
				if (! $file_exists) {
					$text = show_error("Can't open the file named \"" + $file + "\"" + $check_URL);
					$file_missing = 1;
				} else {
					XHO.Send();
					
					// 3) read the file
					$text = XHO.responseText;
	
					// 4) close the file connection
					XHO = "";
				}

				//$output .= "<p>reading " + $file_URL + " over http<p>";  // debug

			} else {

				// 1) prepare the URL for this type of connection
				$file_URL = absolute_path($file, "filesystem");

				// 2) open a connection to the file
				FSO = Server.CreateObject("Scripting.FileSystemObject");
				$file_exists = FSO.FileExists($file_URL);
				if (! $file_exists) {
					$text = show_error("Can't open the file named \"" + $file + "\"" + $check_URL);
					$file_missing = 1;
				} else {
				
					// 3) read the file
					$myfile = FSO.OpenTextFile($file_URL, 1);
					$text = $myfile.ReadAll();
					$file_missing = 0;
	
					// 4) for local files, catch the file's modification date (for $read_page_definitions_from and $template, plus content files when the template contains a env_last_modified tag)
					if ($check_last_modified) {
						$myfile2 = FSO.getFile($file_URL);
						$ASP_date = $myfile2.dateLastModified;
						$JScript_date = new Date($ASP_date);
						$mtime = $JScript_date.getTime();
						if ($mtime > $latest_mod_date) {
							$latest_mod_date = $mtime;
							$year = $JScript_date.getFullYear();
							$month = $JScript_date.getMonth() + 1; if ($month < 10) { $month = "0" + String($month); }
							$day = $JScript_date.getDate(); if ($day < 10) { $day = "0" + String($day); }
							$hour = $JScript_date.getHours();
							if ($hour < 12) {
								$ampm = "am";
							} else {
								$ampm = "pm";
								if ($hour > 12) {
									$hour = $hour - 12;
								}
							}
							//if ($hour < 10) { $hour = "0" + String($hour); }
							$minute = $JScript_date.getMinutes(); if ($minute < 10) { $minute = "0" + String($minute); }
							$latest_mod_date_formatted = $year + "-" + $month + "-" + $day + " - " + $hour + ":" + $minute + " " + $ampm;
						}
					}
			
					// 5a) close the file connection
					$myfile.Close();
					
				}

				// 5b) close the file connection
				FSO = "";

				//$output += "<p>reading " + $file_URL + " through filesystem<p>"; // debug
				
			}
							
			// finally, conform all line breaks to avoid cross-platform issues
			// we'd rather conform to Unix line breaks (\n), but that doesn't work in ASP, which doesn't support the s flag in regular expressions
			$text = $text.replace(/\r\n/g, "\r"); // change DOS to Mac
			$text = $text.replace(/\n/g, "\r"); // change Unix to Mac
			
		}
		return $text;
	}
	
	function get_setting($source_text, $setting, $allow_override, $allow_partial) {
		// allow most preferences to be overridden through the argument string
		$value = "";
		$setting_no_spaces = $setting;
		$setting_no_spaces = String($setting_no_spaces).replace(/[ -]/g, "_");
		$settings_used += $setting_no_spaces + ",";

		$override = (Request.QueryString($setting_no_spaces) != $undefined) ? Request.QueryString($setting_no_spaces) : "" ;
		if (($allow_override)&&($override != "")) {
			$value = $override;
			// don't allow users to pass code through the URL arguments
			$value = $value.replace(/\</, "&lt;");
			$value = $value.replace(/\>/, "&gt;");
		} else {
			$source_text = "\r" + $source_text; // this makes it easy to make sure settings start on a new line
			if ($allow_partial) {  // this lets us use more verbose labels in the ini file
				$re = new RegExp('[^\\w]' + $setting + '[^:\r]*: ([^\r]*)\r*', 'i');
				if ($re.test($source_text)) {
					$value = RegExp.$1;
				}
			} else {  // this ensures an exact match in the pages file
				$re = new RegExp('[^\\w]' + $setting + ': ([^\r]*)\r*', 'i');
				if ($re.test($source_text)) {
					$value = RegExp.$1;
				}
			}
		}
		if ($value == "0") { $value = 0; } // this ensures that a 0 value will evaluate false in every language
		return $value;
	}

	function get_page_names($source) { // return a list of all the page names in a page definitions file
		$page_names = Array();
		// in JScript, we could also set this up as a global match, then loop through the $matches array
		$re = new RegExp("([-\\w]+)\:\\s+[\\w]+", "");
		while ($re.test($source)) {
			$this_page_name = RegExp.$1;
			$page_names.push($this_page_name);
			$source = $source.replace($re, "");
		}
		return $page_names;
	}

	function get_directory_listing($directory) { // return a list of all the items in the specified directory
		$files = new Array();
		FSO = Server.CreateObject("Scripting.FileSystemObject")
		$dir = FSO.GetFolder(absolute_path($directory, "filesystem"));
		$dir_files = new Enumerator($dir.Files);
		if ($dir_files) {
			for (; !$dir_files.atEnd(); $dir_files.moveNext()) { // what the heck...
				$file = $dir_files.item().Name;
				if ($file.substr(0, 1) != ".") { $files.push($file); } // that gets files that don't start with a dot
			}
		}
		// in ASP, we have to do this once for files and once for folders
		$dir_folders = new Enumerator($dir.Subfolders);
		if ($dir_folders) {
			for (; !$dir_folders.atEnd(); $dir_folders.moveNext()) { // what the heck...
				$file = $dir_folders.item().Name;
				if ($file.substr(0, 1) != ".") { $files.push($file); } // that gets files that don't start with a dot
			}  
		}
		FSO = "";
		return $files;
	}
		
	function get_recursive_listing($start_folder, $recursive, $filter) { // return a list of all the files in a given folder, including subfolders
		$start_folder = $start_folder.replace(/[\/\\]$/, ""); // remove a trailing slash
		$file_list = new Array();
		$folder_list = new Array($start_folder);
		while ($folder_list.length > 0) {
			$this_folder_path = $folder_list[0];
			$this_folder_items = get_directory_listing($this_folder_path);
			for ($n=0; $n<$this_folder_items.length; $n++) {
				$this_item_name = $this_folder_items[$n];
				$this_item_path = $this_folder_path + "/" + $this_item_name;
 				// if the item name contains a dot, we assume it's a file, if not, we assume it's a directory
 				if ($this_item_name.indexOf(".") == -1) {
 					// we've found a folder; add it to the list of folders to scan
 					if ($recursive) {
						$folder_list.push($this_item_path);
					}
				} else if ((!$filter)||($this_item_name.indexOf($filter) != -1)) {
					// we've found a file; add it to the list of files to return
					$this_item_path = $this_item_path.replace($start_folder+"/", ""); // make results relative to the start folder, not to the site
					$file_list.push($this_item_path);
				}
			}
			$folder_list.shift(); // remove the folder we just scanned from the list
		}
		return $file_list;
	}
	
	function absolute_path($path, $method) { // convert a reference to a file within our site to an absolute URL
		if ($script_location) { // if this hasn't been set yet, just return the original value

			if ($method == "filesystem") {
			
				$path = Server.MapPath($path);
	
			} else {
			
				$thisserver = (Request.ServerVariables("HTTP_HOST") != $undefined) ? String(Request.ServerVariables("HTTP_HOST")) : "" ;
				$thispath = "";
				$re = new RegExp("\/([^=]*\/)contemplate\/", "i");
				if ($re.test($request)) { $thispath = RegExp.$1; }
				$re = new RegExp("\/([^=]*\/)" + $URL_rewriting_flag + "\/", "i");
				if ($re.test($request)) { $thispath = RegExp.$1; }
				
				// pass along the authentication information if present
				$auth_info = (Request.ServerVariables("HTTP_AUTHORIZATION") != $undefined) ? String(Request.ServerVariables("HTTP_AUTHORIZATION")) : "" ;
				if (($auth_info)&&($auth_info.substr(0, 5) == "Basic")) {
					$auth_info = $auth_info.substr(5);
					$login = Base64Decode($auth_info);
					$login += "@";
				} else {
					$login = "";
				}
				
				$path = $path.replace("../", "http://" + $login + $thisserver + "/" + $thispath, ""); // replace the first updelim with the scheme and path
				$path = $path.replace("../", "", "g"); // remove additional updelims
			
			}
		
		}
		return $path;
	}

	function show_error($message) { // the only purpose for this here is to prevent the script from halting if one of the shared functions throws an error
		return "Error: " + $message;
	}
	

// set up some error messages that we can use later

	$check_URL = "<br>Hint: Check your page definition";
	$check_embed = "<br>Hint: Check your embed tag";
	$check_field_label = "<br>Hint: Check your content file and remove any formatting tags between the field marker and the field label";
	

// set up some primary variables

	$URL_rewriting_flag = "assembled"; // we'd rather store this in the preferences file, but we need it in order to read the preferences file!

	// figure out the location of the contemplate directory as shown in the browser, and use that as the basis for open commands;
	// this allows us to run the script from a symlink to the real contemplate folder, and paths will be relative to the
	// apparent, rather than the actual, location of assembler.asp
	// this will also prevent problems if Windows calculates relative paths from the server root
	$request = ((Request.ServerVariables("OS") != $undefined)&&(String(Request.ServerVariables("OS")).indexOf("Win") != -1)) ? String(Request.ServerVariables("SCRIPT_NAME")) : ( (String(Request.ServerVariables("REQUEST_URI")).indexOf("?") != -1) ? String(Request.ServerVariables("REQUEST_URI")).substr(0, String(Request.ServerVariables("REQUEST_URI")).indexOf("?")) : String(Request.ServerVariables("REQUEST_URI")) ) ;
	$script_location = (Request.ServerVariables("PATH_TRANSLATED") != $undefined) ? String(Request.ServerVariables("PATH_TRANSLATED")) : "" ;
	$script_location = $script_location.replace(/\\/g, "/");
	$re = new RegExp("(.*\/)" + $URL_rewriting_flag + "\/", "i");
	if ($re.test($script_location)) {
		$script_location = RegExp.$1 + "contemplate/";
	} else {
		$re = new RegExp("(.*\/)[^\/]+", "");
		if ($re.test($script_location)) { $script_location = RegExp.$1; }
	}


// get some preference settings from the preferences file

	$preferences = get_file("../data/preferences.ini", "filesystem", 0);
	if ($preferences) { $read_page_definitions_from = "../" + get_setting($preferences, "read page definitions from", 0, 1); }
	if (($read_page_definitions_from == "../")||($read_page_definitions_from == "")) { $read_page_definitions_from = "../data/pages.txt"; }
	//if ($preferences) { $URL_rewriting_flag = get_setting($preferences, "URL rewriting flag", 0, 1); }
	//if ($URL_rewriting_flag == "") { $URL_rewriting_flag = "assembled"; }


// get the current contents of the page definitions file

	$pages_file = get_file($read_page_definitions_from, "filesystem", 0);
	
	
// warn the user about a possible browser limitation on textarea contents

	if (($pages_file.length > 30000)&&(navigator.platform.indexOf("Mac") != -1)&&(navigator.appName.indexOf("MSIE") != -1)) {
		$size_warning = "<p class=body><font color=#FF0000>WARNING: Your browser may truncate the list of page definitions in the field below. Please check that the list is complete, and use a different browser if necessary.</font></p>";
	} else {
		$size_warning = "";
	}
	

// set up the HTML page

	Response.write("<html>\r\r");
	
	Response.write("	<head>\r\r");
		
	Response.write("		<title>Contemplate</title>\r\r");
			
	Response.write("		<link rel=stylesheet href=../stylesheet.css type=text/css>\r\r");
		
	Response.write("	</head>\r\r");
		
	Response.write("	<body bgcolor=#FFFFFF onload=set_textarea()>\r\r");
		
	Response.write(			$size_warning);
				
	Response.write("		<form name=contemplate method=post action=save.asp>\r\r");
			
	Response.write("			<textarea name=pages_file cols=100 rows=30 wrap=off class=body>" + $pages_file + "</textarea>\r\r");
	
	Response.write("			<input type=hidden name=action value=" + $action + ">");
	
	Response.write("		</form>\r\r");
	

// add, edit, or delete the definition

	Response.write("	<script language=JavaScript>\r\r");
		
	Response.write("		function set_textarea() {\r");
	Response.write("			delimiter = (parent.args != '') ? '&' : '' ;\r");
	Response.write("			if ((parent.action == 'page')||(parent.action == 'template')) {\r");
	Response.write("				// if we're adding, just put the new definition at the top...\r");
	Response.write("				//document.contemplate.pages_file.value = '" + $page_name + ": template=' + parent.template + delimiter + parent.args + '\\r\\n' + document.contemplate.pages_file.value + '\\r\\n';\r");
	Response.write("				// ...or the bottom\r");
	Response.write("				document.contemplate.pages_file.value = document.contemplate.pages_file.value + '\\r\\n" + $page_name + ": template=' + parent.template + delimiter + parent.args + '\\r\\n';\r");
	Response.write("			} else if (parent.action == 'edit') {\r");
	Response.write("				// if we're editing, overwrite the old page definition\r");
	Response.write("				document.contemplate.pages_file.value = document.contemplate.pages_file.value.replace(/" + $page_name + ": [^\\r\\n]*/i, '" + $page_name + ": template=' + parent.template + delimiter + parent.args);\r");
	Response.write("			} else if (parent.action == 'delete') {\r");
	Response.write("				// if we're deleting, remove the old page definition\r");
	Response.write("				document.contemplate.pages_file.value = document.contemplate.pages_file.value.replace(/" + $page_name + ": [^\\r\\n]*\\s?/i, '');\r");
	Response.write("			}\r\r");
	Response.write("		}\r");
			
	Response.write("	</script>\r\r");
	
	
// finish off the page

	Response.write("</body></html>\r\r");

%>